#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include <cstdlib>
#include <stdlib.h>
#include <cassert>
#include <string.h>
#include <chrono>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <bitset>
#include <array>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <functional>
#include <numeric>
#include <complex>
#include <random>
#include <cstdlib>

using namespace std;

ifstream fin("cb.in");
ofstream fout("cb.out");

int main() {
  int n, m;
  fin >> n >> m;

  vector<int> a(n);
  for (int& x : a) {
    fin >> x;
  }

  sort(a.begin(), a.end());
  for (int i = 1; i < n; ++i) {
    assert(a[i - 1] != a[i]);
  }

  queue<pair<int, int>> q;
  q.emplace(0, m - 1);
  vector<int> pos;

  while (!q.empty() && (int)pos.size() < n) {
    int left, right;
    tie(left, right) = q.front();
    q.pop();

    int mid = (left + right) >> 1;
    pos.emplace_back(mid);

    if (left <= mid - 1) {
      q.emplace(left, mid - 1);
    }

    if (mid + 1 <= right) {
      q.emplace(mid + 1, right);
    }
  }

  sort(pos.begin(), pos.end());

  vector<int> sol(m, 1);
  int ptrA = 0;

  for (const int& p : pos) {
    sol[p] = a[ptrA++];
  } 

  for (int i = 0; i < m; ++i) {
    if (i > 0 && sol[i] < sol[i - 1]) {
      sol[i] = sol[i - 1];
    }

    fout << sol[i] << ' ';
  }

  fout << '\n';

  return 0;
}


